(function(g,f){typeof exports==='object'&&typeof module!=='undefined'?f(exports,require('tslib')):typeof define==='function'&&define.amd?define(['exports','tslib'],f):(g=g||self,f(g.evangelist={},g.tslib_1));}(this,function(exports, tslib_1){'use strict';function compose() {
    var funcs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        funcs[_i] = arguments[_i];
    }
    return funcs.reduce(function (previousFunction, currentFunction) {
        // eslint-disable-next-line implicit-arrow-linebreak
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            // eslint-disable-next-line implicit-arrow-linebreak
            return currentFunction(previousFunction.apply(void 0, args));
        };
    });
}function curry(func) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return function () {
        var args2 = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args2[_i] = arguments[_i];
        }
        return func.apply(void 0, args.concat(args2));
    };
}function curryRight(func) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    return function () {
        var args2 = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args2[_i] = arguments[_i];
        }
        return func.apply(void 0, args2.concat(args));
    };
}function decorate(target, decorator) {
    return function func() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return decorator.apply(void 0, args.concat([target]));
    };
}function dispatcher(state, mutators, subscribers) {
    return tslib_1.__awaiter(this, void 0, Promise, function () {
        var hasSubscribers, index, next;
        var _this = this;
        return tslib_1.__generator(this, function (_a) {
            hasSubscribers = (subscribers !== undefined);
            index = 0;
            next = function (newState) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                var layer;
                var _this = this;
                return tslib_1.__generator(this, function (_a) {
                    layer = mutators[index];
                    if (layer === undefined) {
                        return [2 /*return*/, newState];
                    }
                    index += 1;
                    return [2 /*return*/, layer(newState, function (currentState) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                            return tslib_1.__generator(this, function (_a) {
                                if (hasSubscribers) {
                                    // @ts-ignore
                                    subscribers.forEach(function (subscriber) {
                                        subscriber({ action: layer.name, previousState: newState, newState: currentState });
                                    });
                                }
                                return [2 /*return*/, next(currentState)];
                            });
                        }); })];
                });
            }); };
            return [2 /*return*/, next(state)];
        });
    });
}function emitter(events, eventName, args, subscribers) {
    return tslib_1.__awaiter(this, void 0, Promise, function () {
        var isEventWildcard, argsPass, _loop_1, _i, _a, eventKey;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    isEventWildcard = (eventName === '*');
                    argsPass = (args !== undefined) ? args : [];
                    _loop_1 = function (eventKey) {
                        var _loop_2, _i, _a, eventSubscriber;
                        return tslib_1.__generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    if (!isEventWildcard && eventName !== eventKey) {
                                        return [2 /*return*/, "continue"];
                                    }
                                    _loop_2 = function (eventSubscriber) {
                                        return tslib_1.__generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    if (subscribers !== undefined) {
                                                        subscribers.forEach(function (subscriber) {
                                                            subscriber({ event: eventKey, subscriber: eventSubscriber.name, args: args });
                                                        });
                                                    }
                                                    // eslint-disable-next-line no-await-in-loop
                                                    return [4 /*yield*/, eventSubscriber.apply(void 0, argsPass)];
                                                case 1:
                                                    // eslint-disable-next-line no-await-in-loop
                                                    _a.sent();
                                                    return [2 /*return*/];
                                            }
                                        });
                                    };
                                    _i = 0, _a = events[eventKey];
                                    _b.label = 1;
                                case 1:
                                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                                    eventSubscriber = _a[_i];
                                    return [5 /*yield**/, _loop_2(eventSubscriber)];
                                case 2:
                                    _b.sent();
                                    _b.label = 3;
                                case 3:
                                    _i++;
                                    return [3 /*break*/, 1];
                                case 4: return [2 /*return*/];
                            }
                        });
                    };
                    _i = 0, _a = Object.keys(events);
                    _b.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                    eventKey = _a[_i];
                    return [5 /*yield**/, _loop_1(eventKey)];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    });
}function iterate(iterable, func) {
    return tslib_1.__awaiter(this, void 0, Promise, function () {
        var _i, _a, value;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _i = 0;
                    return [4 /*yield*/, iterable];
                case 1:
                    _a = _b.sent();
                    _b.label = 2;
                case 2:
                    if (!(_i < _a.length)) return [3 /*break*/, 5];
                    value = _a[_i];
                    // eslint-disable-next-line no-await-in-loop
                    return [4 /*yield*/, func(value)];
                case 3:
                    // eslint-disable-next-line no-await-in-loop
                    _b.sent();
                    _b.label = 4;
                case 4:
                    _i++;
                    return [3 /*break*/, 2];
                case 5: return [2 /*return*/];
            }
        });
    });
}exports.compose=compose;exports.curry=curry;exports.curryRight=curryRight;exports.decorate=decorate;exports.dispatcher=dispatcher;exports.emitter=emitter;exports.iterate=iterate;Object.defineProperty(exports,'__esModule',{value:true});}));//# sourceMappingURL=index.min.js.map
